/*
	Copyright (C) 2020-2022 Lewis ANESA.

	This file is part of ladspa-tool-kit

	ladspa-tool-kit is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	ladspa-tool-kit is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with ladspa-tool-kit.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef __LTK_UTILS_H__
#define __LTK_UTILS_H__

#include <stdarg.h>
#include <stdint.h>
#include <unistd.h>
#include <limits.h>

/* Utility functions */

/* Use PRINTXX with -D_XOPEN_SOURCE=700 compilation flag */
#define PRINT64		"llu"
#define PRINT32		"llu"

#if (LONG_BIT == 64)
#undef PRINT64
#define PRINT64		"lu"
#endif

#if (WORD_BIT == 64)
#undef PRINT64
#define PRINT64		"u"
#endif

#if (LONG_BIT == 32)
#undef PRINT32
#define PRINT32		"lu"
#endif

#if (WORD_BIT == 32)
#undef PRINT32
#define PRINT32		"u"
#endif

uint32_t LTKRand (uint32_t);
#define LTK_RANDOM(seed) ((((seed) = LTKrand(seed)) >> 16) & ~0x8000)
uint64_t LTKHash (uint64_t);
#define LTK_HASH(seed) ((seed) = LTKHash(seed))

void *LTKArray(size_t, ...);
void *LTKmemcpy(uint8_t *, uint8_t *, size_t);
char *LTKBacktrace(char *, char *, char *, char *);

#endif /* __LTK_UTILS_H__ */
